/**
 * Ce programme sert  dcrire l'utilisation des interfaces Comparable et Comparator.
 *
 * @author Ren Lalement: "Objets, Algorithmes, Patterns", http://cermics.enpc.fr/polys/oap/node106.html
 * @author Mohamed Lokbani (qcqs commentaires en plus)
 * @version 1.2
 *
 */

import java.util.*;


class Nom implements Comparable {
    private String prnom, nom;
      
    String valNom() {return nom;}
    String valPrnom() {return prnom;}
      
    public Nom(String prnom, String nom) {
        if (prnom==null || nom==null)
            throw new NullPointerException();
        this.prnom = prnom;
        this.nom = nom;
    }

    public boolean equals(Object o) {
        return
            o instanceof Nom &&
            ((Nom)o).prnom.equals(prnom) &&
            ((Nom)o).nom.equals(nom);
    }
  
    public int hashCode() {
        return 31*prnom.hashCode() + nom.hashCode();
    }
  
    public int compareTo(Object o) {
        Nom n = (Nom)o;
        int compNom = nom.compareTo(n.nom);
        return 
            compNom!=0 ? compNom : prnom.compareTo(n.prnom);
    }
  
    public String toString() {
        return prnom + " " + nom;
    }
}


class PrnomComparator implements Comparator {
    public int compare(Object o1, Object o2) {
        Nom r1 = (Nom) o1;
        Nom r2 = (Nom) o2;
        int prnomComp = 
            r1.valPrnom().compareTo(r2.valPrnom());
        if (prnomComp != 0) 
            return prnomComp;
        else
            return r1.valNom().compareTo(r2.valNom());
    }
}
 
class TestcmpTo{
    public static void main(String[] args) {
        Comparator prnomComparator = new PrnomComparator();
        List l = new ArrayList();
        l.add(new Nom("Jacque","Brel"));
        l.add(new Nom("Jackie","Stewart"));
        l.add(new Nom("Jackie","Chan"));


        Collections.sort(l);
        System.out.println("Comparable: " + l);

        Collections.sort(l, prnomComparator);
        System.out.println("Comparator: " + l);

    }
}

/*

Affichage en sortie

Comparable: [Jacque Brel, Jackie Chan, Jackie Stewart]
Comparator: [Jackie Chan, Jackie Stewart, Jacque Brel]

*/
